

class mcx_session_client;

class mcx_router_client : public FIX8::FIX44::mcx44_Router
{
	mcx_session_client& _session;

public:
			
	mcx_router_client(mcx_session_client& session) : _session(session) { }
					
	virtual bool operator() (const FIX8::FIX44::ExecutionReport *msg) const;
};

class mcx_session_client : public FIX8::Session
{
	mcx_router_client _router;

protected:

	virtual FIX8::Message *generate_logon(const unsigned heartbeat_interval, const FIX8::f8String davi = FIX8::f8String());

	virtual bool handle_logon(const unsigned seqnum, const FIX8::Message *msg);
	virtual bool handle_logout(const unsigned seqnum, const FIX8::Message *msg);

public:
			
	mcx_session_client(const FIX8::F8MetaCntx& ctx, const FIX8::SessionID& sid, FIX8::Persister *persist=0,
		FIX8::Logger *logger=0, FIX8::Logger *plogger=0) : Session(ctx, sid, persist, logger, plogger), _router(*this) { }
						
	bool handle_application(const unsigned seqnum, const FIX8::Message *&msg);
};

ref class F8SessionWrapper
{
private:
	FIX8::ClientSession<mcx_session_client> *_session;
	System::Runtime::InteropServices::GCHandle _handle;

	void OnSendMessage(Object ^state);

public:

	F8SessionWrapper(FIX8::ClientSession<mcx_session_client> *session) : _session(session) 
	{
		_handle = System::Runtime::InteropServices::GCHandle::Alloc(this);
	}

	void SendMessage();
};